!*($) BERTA ..........BERTA ..........BERTA ..........BERTA ..........
      SUBROUTINE BERTA (NAMTBL,NAMBUK)
      USE BUKDEF
      IMPLICIT NONE
      CHARACTER*(*), INTENT(IN) :: NAMTBL,NAMBUK
!==X====================================================================
! #TEST#
!-----------------------------------------------------------------------
! (C) Copyright INTES GmbH, Stuttgart, Germany   MA    Jan-2005        1
!!mod--------------------------------------------MA-03-Dec-2008-15:41:08
      CHARACTER*8, PARAMETER :: NAMSUB='BERTA'
      TYPE (BUKDES) :: IGDES
      INTEGER  IDBOOK,IDTBL,NOFTUP
      LOGICAL  OK
! <%>
      CALL PRINIT (NAMSUB)
!----
!err
!
!     > Access and test data objects
!      ------------------------------
      CALL ERRC1 (1 123 4567,2,'namsub',3,NAMSUB,ERRC1)
!ERR  this 999999 and %i on XXX and 999 and $F_(PN) on XXX and XXX
!ERR  t               his 9g99 and $F_(PFIL) on XXX and 999 and %E
!ERR  this 999 and 999.999E999 sdfkjf XXXX sdfsdkj XXXx
!ERR  this 999 and 999.999 ff
      CALL ERFC1 (1 010 5003,NAMSUB,HUGO,
                             NAMSUB,HUGO)
!*10  (%s): Illegal value for integer parameter %s=%i
      GOTO 999
!     999

      CALL ERRC1 (1 123 4567

!*10
!     CCCCCCCccXXXXXXXXXXXXXXXXx


      '%& this %#14.3s and %(that) and %X ')
      CALL FMT1 ('this %s and %(that) and %e ')
      CALL PRITBL (NAMTBL,1, I D T B L , N O F T U P )
      CALL PRMBUK (NAMBUK,1, I D B O O K , I G D E S )
!
!     > Additional tests
      CALL PRCTBL (IDTBL,3,NOFCOL,-1)
      CALL PRCBUK (IDBOOK,NROWP,NCOLP,NGROWS,NGCOLS,IATOM,MFORM)
      CALL PRSTART ( O K )
      IF (.NOT.OK) GOTO 901
!
!
!     > Operation branch
!      ------------------
       CALL ERRCC (3 010 0006,2,NAMSUB,6,'PR-Routine')
!*10  Routine XXXXXXXX: XXXXXXXXXXXXXXXXXXXXXXX not (fully) implemented
      GOTO 999
!
!
!     > Errors
!      --------
  901 CALL PRERR2 (...
!
!----
  999 CALL PREXIT (NAMSUB)
      END ??? ???
!*($) BERTA ..........BERTA ..........BERTA ..........BERTA ..........
      SUBROUTINE EPSM (ELDA,BSYS,SRHO,SM,ELWG,KMASS,NOFHRM)
                                            CHARACTER*(*)   ELDA,BSYS,SRHO,SM,ELWG
                         NTEGER         KMASS
         =X====================================================================
!  #SYPROC# Processor to build the mass matrix on element level,
!           always in single precision.
!
! -->  ELDA   -  name of ELDA book
! -->  BSYS   -  name of rotated basis book
! -->  SRHO   -  name of element displacement book
! -->  SM     -  name of small m book
! -->  ELWG   -  name of weigth information book
! -->  KMASS  -  mass kind
!                = 0: diagonal mass matrix requested
!                = 1: consistent mass matrix requested
! -->  NOFHRM -  no. of harmonic for axisymmetric analysis
! -->            >= 0 : symmetric, < 0 antimetric harmonic
!
!      Involved data objects:  ELDA.  (Read)
!                              BSYS   (Read)  optional
!                              SRHO   (Read)  optional
!                              SM     (Create)
!                              ELWG   (Create)
!
!-----------------------------------------------------------------------
! (C) Copyright INTES GmbH, Stuttgart, Germany   KS    Sep-1991        5
!!mod--------------------------------------------MA-12-Aug-2005-10:26:04
      PARAMETER      (LENDES = 12, NOFDBJ = 7)
      INTEGER        IGELDA(LENDES), IGDES(LENDES), IGSM(LENDES)
      INTEGER        NAMSET(3), LIDDBJ(NOFDBJ)
      CHARACTER*12   SET
      CHARACTER*40   NAMRES(3)
      LOGICAL        OK, BUKEXI, SETEXI, LERASK
!
      DATA IGSM   / 3 , 3 , 3 , 0 , 0 , 1 , 1 , 0 , 1 , 0 , 0 , 0 /
      DATA NAMRES /'Element Mass Matrix (consistent)        ',
     &             'Element Mass Matrix (diagonal)          ',
     &             'Element Inertia Characteristics         '/
!-----------------------------------------------------------------------
!
      CALL PRINIT('EPSM')
!
!.... get data objects
      CALL QIZERO( L I D D B J ,NOFDBJ)
!
      CALL PRIBUK (ELDA,+1, L I D D B J (1) , I G E L D A )
!
      IF (BUKEXI(BSYS)) THEN
         CALL PRIBUK (BSYS,+1, L I D D B J (2) , I G D E S )
      ENDIF
!
      IF (SRHO == ' ') THEN
         NBSRHO  = 0
      ELSE
         IF (BUKEXI(SRHO)) THEN
            CALL PRIBUK (SRHO,1, L I D D B J (7) , I G D E S )
         ELSE
            NBSRHO  = 0
         ENDIF
      ENDIF
!
      IGSM(4) = IGELDA(4)
      IGSM(5) = IGELDA(4)
!
      IF (KMASS == 1) THEN
         IDIAG=0
         IGSM( 8) = 3
         IGSM(10) = 10701
         IGSM(11) = 0
         CALL PRNBUK (SM,IGSM,0,NAMRES(1),+1, L I D D B J (3) )
      ELSE IF (KMASS == 0) THEN
         IDIAG=1
         IGSM( 8) = 2
         IGSM(10) = 10700
         IGSM(11) = 0
         CALL PRNBUK (SM,IGSM,0,NAMRES(2),+1, L I D D B J (3) )
      ELSE
         CALL ERR (2 363 0029)
!ERR  Invalid mass matrix type, only 0(diag)  or 1(cons) allowed.
      ENDIF
!                            ...Insert local system info
      IF (LIDDBJ(2) > 0) THEN
          ICORD = 2
          CALL STGDES (LIDDBJ(3),'ICORD',1,ICORD)
      ENDIF
!
      IGSM( 8) = 2
      IGSM(10) = 0
      IGSM(11) = 0
      CALL PRNBUK (ELWG,IGSM,0,NAMRES(3),+2, L I D D B J (4) )
!
      CALL PRSTART ( O K )
      IF (OK) THEN
!
         CALL ERRASK ( N E R I )
!
! Look for element set
         SET='ELEMDISP'
         CALL CVCHA4(SET,3, N A M S E T )
         IF (.NOT.SETEXI(NAMSET,2)) THEN
!
            CALL ERRC(3 010 2108,3,SET)
!*10  Set XXXXXXXXXXXX does not exist.
!
         ELSE
!
! Initialize set access
            CALL SETINI(0)
            CALL STXIN(NAMSET,2, I N C A )
!
! Get set information
            CALL STXINF(INCA, I T M T Y P , I O R D E R , N O F E L )
!
            IF (NOFEL <= 0) THEN
!
               CALL ERRC(4 010 2109,3,SET)
!*10  Set XXXXXXXXXXXX is empty.
!
            ELSE
!
! Calculate matrix
               CALL SMWORK(LIDDBJ,0,INCA,NOFEL,IDIAG,NOFHRM)
!
            ENDIF
!
! Terminate set access
            CALL SETERM
!
         ENDIF
!
! Check no. of errors
         IF (.NOT.LERASK(NERI)) THEN
            CALL PRBBUK (LIDDBJ(3))
            CALL PRBBUK (LIDDBJ(4))
         ENDIF
!
      ENDIF
!
      CALL PREXIT('EPSM')
      END SUBROUTINE EPSM
!*($) BERTA ..........BERTA ..........BERTA ..........BERTA ..........
      INTEGER FUNCTION BERTA ()
      IMPLICIT NONE
!==I====================================================================
! #TEST#
!-----------------------------------------------------------------------
! (C) Copyright INTES GmbH, Stuttgart, Germany   MA    Nov-2008        1
!!mod--------------------------------------------MA-24-Nov-2008-10:59:09
      CHARACTER*12,PARAMETER :: NAMSUB='BERTA'
! <%>
      CALL TRACIN (NAMSUB)
!----
      CALL ERFC0 (1 010 5000,NAMSUB,'Part-X')
!*10  (%s): Routine not (fully) implemented
!----
  999 CALL TRACEX (NAMSUB)
      END FUNCTION BERTA
